<?php
/**
 * DeliveryOrderPlaceItemReadonlyProperties
 *
 * PHP version 5
 *
 * @category Class
 * @package  Ensi\LogisticClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * Ensi Logistic
 *
 * Управление логистикой
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: mail@greensight.ru
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 4.3.1
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace Ensi\LogisticClient\Dto;

use \ArrayAccess;
use \Ensi\LogisticClient\ObjectSerializer;

/**
 * DeliveryOrderPlaceItemReadonlyProperties Class Doc Comment
 *
 * @category Class
 * @package  Ensi\LogisticClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class DeliveryOrderPlaceItemReadonlyProperties implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'DeliveryOrderPlaceItemReadonlyProperties';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'id' => 'int',
        'delivery_order_place_id' => 'int',
        'vendor_code' => 'string',
        'barcode' => 'string',
        'name' => 'string',
        'qty' => 'float',
        'qty_delivered' => 'float',
        'height' => 'int',
        'length' => 'int',
        'width' => 'int',
        'weight' => 'int',
        'assessed_cost' => 'int',
        'cost' => 'int',
        'cost_vat' => 'int',
        'price' => 'int',
        'created_at' => '\DateTime',
        'updated_at' => '\DateTime'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPIFormats = [
        'id' => null,
        'delivery_order_place_id' => null,
        'vendor_code' => null,
        'barcode' => null,
        'name' => null,
        'qty' => 'float',
        'qty_delivered' => 'float',
        'height' => null,
        'length' => null,
        'width' => null,
        'weight' => null,
        'assessed_cost' => null,
        'cost' => null,
        'cost_vat' => null,
        'price' => null,
        'created_at' => 'date-time',
        'updated_at' => 'date-time'
    ];

    /**
      * Array of nullable properties. Used for (de)serialization
      *
      * @var boolean[]
      */
    protected static $openAPINullables = [
        'id' => false,
        'delivery_order_place_id' => false,
        'vendor_code' => true,
        'barcode' => true,
        'name' => false,
        'qty' => false,
        'qty_delivered' => true,
        'height' => false,
        'length' => false,
        'width' => false,
        'weight' => false,
        'assessed_cost' => false,
        'cost' => false,
        'cost_vat' => false,
        'price' => false,
        'created_at' => false,
        'updated_at' => false
    ];

    /**
      * If a nullable field gets set to null, insert it here
      *
      * @var boolean[]
      */
    protected $openAPINullablesSetToNull = [];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

        /**
     * Array of property to nullable mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPINullables()
    {
        return self::$openAPINullables;
    }

    /**
     * Array of nullable field names deliberately set to null
     *
     * @return array
     */
    public function getOpenAPINullablesSetToNull()
    {
        return $this->openAPINullablesSetToNull;
    }

    public function setOpenAPINullablesSetToNull($nullablesSetToNull)
    {
        $this->openAPINullablesSetToNull=$nullablesSetToNull;
        return $this;
    }

    /**
     * Checks if a property is nullable
     *
     * @return bool
     */
    public static function isNullable(string $property): bool
    {
        if (isset(self::$openAPINullables[$property])) {
            return self::$openAPINullables[$property];
        }

        return false;
    }

    /**
     * Checks if a nullable property is set to null.
     *
     * @return bool
     */
    public function isNullableSetToNull(string $property): bool
    {
        if (in_array($property, $this->getOpenAPINullablesSetToNull())) {
            return true;
        }
        return false;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'delivery_order_place_id' => 'delivery_order_place_id',
        'vendor_code' => 'vendor_code',
        'barcode' => 'barcode',
        'name' => 'name',
        'qty' => 'qty',
        'qty_delivered' => 'qty_delivered',
        'height' => 'height',
        'length' => 'length',
        'width' => 'width',
        'weight' => 'weight',
        'assessed_cost' => 'assessed_cost',
        'cost' => 'cost',
        'cost_vat' => 'cost_vat',
        'price' => 'price',
        'created_at' => 'created_at',
        'updated_at' => 'updated_at'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'delivery_order_place_id' => 'setDeliveryOrderPlaceId',
        'vendor_code' => 'setVendorCode',
        'barcode' => 'setBarcode',
        'name' => 'setName',
        'qty' => 'setQty',
        'qty_delivered' => 'setQtyDelivered',
        'height' => 'setHeight',
        'length' => 'setLength',
        'width' => 'setWidth',
        'weight' => 'setWeight',
        'assessed_cost' => 'setAssessedCost',
        'cost' => 'setCost',
        'cost_vat' => 'setCostVat',
        'price' => 'setPrice',
        'created_at' => 'setCreatedAt',
        'updated_at' => 'setUpdatedAt'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'delivery_order_place_id' => 'getDeliveryOrderPlaceId',
        'vendor_code' => 'getVendorCode',
        'barcode' => 'getBarcode',
        'name' => 'getName',
        'qty' => 'getQty',
        'qty_delivered' => 'getQtyDelivered',
        'height' => 'getHeight',
        'length' => 'getLength',
        'width' => 'getWidth',
        'weight' => 'getWeight',
        'assessed_cost' => 'getAssessedCost',
        'cost' => 'getCost',
        'cost_vat' => 'getCostVat',
        'price' => 'getPrice',
        'created_at' => 'getCreatedAt',
        'updated_at' => 'getUpdatedAt'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->setIfExists('id', $data, null);
        $this->setIfExists('delivery_order_place_id', $data, null);
        $this->setIfExists('vendor_code', $data, null);
        $this->setIfExists('barcode', $data, null);
        $this->setIfExists('name', $data, null);
        $this->setIfExists('qty', $data, null);
        $this->setIfExists('qty_delivered', $data, null);
        $this->setIfExists('height', $data, null);
        $this->setIfExists('length', $data, null);
        $this->setIfExists('width', $data, null);
        $this->setIfExists('weight', $data, null);
        $this->setIfExists('assessed_cost', $data, null);
        $this->setIfExists('cost', $data, null);
        $this->setIfExists('cost_vat', $data, null);
        $this->setIfExists('price', $data, null);
        $this->setIfExists('created_at', $data, null);
        $this->setIfExists('updated_at', $data, null);
    }

    public function setIfExists(string $variableName, $fields, $defaultValue)
    {
        if (is_array($fields) && array_key_exists($variableName, $fields) && is_null($fields[$variableName]) && self::isNullable($variableName)) {
            array_push($this->openAPINullablesSetToNull, $variableName);
        }

        $this->container[$variableName] = isset($fields[$variableName]) ? $fields[$variableName] : $defaultValue;

        return $this;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets id
     *
     * @return int|null
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param int|null $id Идентификатор товара места (коробки) в заказе на доставку
     *
     * @return $this
     */
    public function setId($id)
    {


        /*if (is_null($id)) {
            throw new \InvalidArgumentException('non-nullable id cannot be null');
        }*/
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets delivery_order_place_id
     *
     * @return int|null
     */
    public function getDeliveryOrderPlaceId()
    {
        return $this->container['delivery_order_place_id'];
    }

    /**
     * Sets delivery_order_place_id
     *
     * @param int|null $delivery_order_place_id Идентификатор места (коробки) в заказе на доставку
     *
     * @return $this
     */
    public function setDeliveryOrderPlaceId($delivery_order_place_id)
    {


        /*if (is_null($delivery_order_place_id)) {
            throw new \InvalidArgumentException('non-nullable delivery_order_place_id cannot be null');
        }*/
        $this->container['delivery_order_place_id'] = $delivery_order_place_id;

        return $this;
    }

    /**
     * Gets vendor_code
     *
     * @return string|null
     */
    public function getVendorCode()
    {
        return $this->container['vendor_code'];
    }

    /**
     * Sets vendor_code
     *
     * @param string|null $vendor_code Артикул товара
     *
     * @return $this
     */
    public function setVendorCode($vendor_code)
    {

        if (is_null($vendor_code)) {
            array_push($this->openAPINullablesSetToNull, 'vendor_code');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('vendor_code', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['vendor_code'] = $vendor_code;

        return $this;
    }

    /**
     * Gets barcode
     *
     * @return string|null
     */
    public function getBarcode()
    {
        return $this->container['barcode'];
    }

    /**
     * Sets barcode
     *
     * @param string|null $barcode Штрихкод на товаре
     *
     * @return $this
     */
    public function setBarcode($barcode)
    {

        if (is_null($barcode)) {
            array_push($this->openAPINullablesSetToNull, 'barcode');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('barcode', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['barcode'] = $barcode;

        return $this;
    }

    /**
     * Gets name
     *
     * @return string|null
     */
    public function getName()
    {
        return $this->container['name'];
    }

    /**
     * Sets name
     *
     * @param string|null $name Наименование товара
     *
     * @return $this
     */
    public function setName($name)
    {


        /*if (is_null($name)) {
            throw new \InvalidArgumentException('non-nullable name cannot be null');
        }*/
        $this->container['name'] = $name;

        return $this;
    }

    /**
     * Gets qty
     *
     * @return float|null
     */
    public function getQty()
    {
        return $this->container['qty'];
    }

    /**
     * Sets qty
     *
     * @param float|null $qty Кол-во товара
     *
     * @return $this
     */
    public function setQty($qty)
    {


        /*if (is_null($qty)) {
            throw new \InvalidArgumentException('non-nullable qty cannot be null');
        }*/
        $this->container['qty'] = $qty;

        return $this;
    }

    /**
     * Gets qty_delivered
     *
     * @return float|null
     */
    public function getQtyDelivered()
    {
        return $this->container['qty_delivered'];
    }

    /**
     * Sets qty_delivered
     *
     * @param float|null $qty_delivered Заполняется только при частичной доставке и показывает сколько вложимых выкуплено
     *
     * @return $this
     */
    public function setQtyDelivered($qty_delivered)
    {

        if (is_null($qty_delivered)) {
            array_push($this->openAPINullablesSetToNull, 'qty_delivered');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('qty_delivered', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['qty_delivered'] = $qty_delivered;

        return $this;
    }

    /**
     * Gets height
     *
     * @return int|null
     */
    public function getHeight()
    {
        return $this->container['height'];
    }

    /**
     * Sets height
     *
     * @param int|null $height Высота единицы товара (в мм)
     *
     * @return $this
     */
    public function setHeight($height)
    {


        /*if (is_null($height)) {
            throw new \InvalidArgumentException('non-nullable height cannot be null');
        }*/
        $this->container['height'] = $height;

        return $this;
    }

    /**
     * Gets length
     *
     * @return int|null
     */
    public function getLength()
    {
        return $this->container['length'];
    }

    /**
     * Sets length
     *
     * @param int|null $length Длина единицы товара (в мм)
     *
     * @return $this
     */
    public function setLength($length)
    {


        /*if (is_null($length)) {
            throw new \InvalidArgumentException('non-nullable length cannot be null');
        }*/
        $this->container['length'] = $length;

        return $this;
    }

    /**
     * Gets width
     *
     * @return int|null
     */
    public function getWidth()
    {
        return $this->container['width'];
    }

    /**
     * Sets width
     *
     * @param int|null $width Ширина единицы товара (в мм)
     *
     * @return $this
     */
    public function setWidth($width)
    {


        /*if (is_null($width)) {
            throw new \InvalidArgumentException('non-nullable width cannot be null');
        }*/
        $this->container['width'] = $width;

        return $this;
    }

    /**
     * Gets weight
     *
     * @return int|null
     */
    public function getWeight()
    {
        return $this->container['weight'];
    }

    /**
     * Sets weight
     *
     * @param int|null $weight Вес единицы товара (в граммах)
     *
     * @return $this
     */
    public function setWeight($weight)
    {


        /*if (is_null($weight)) {
            throw new \InvalidArgumentException('non-nullable weight cannot be null');
        }*/
        $this->container['weight'] = $weight;

        return $this;
    }

    /**
     * Gets assessed_cost
     *
     * @return int|null
     */
    public function getAssessedCost()
    {
        return $this->container['assessed_cost'];
    }

    /**
     * Sets assessed_cost
     *
     * @param int|null $assessed_cost Оценочная стоимость единицы товара (в копейках)
     *
     * @return $this
     */
    public function setAssessedCost($assessed_cost)
    {


        /*if (is_null($assessed_cost)) {
            throw new \InvalidArgumentException('non-nullable assessed_cost cannot be null');
        }*/
        $this->container['assessed_cost'] = $assessed_cost;

        return $this;
    }

    /**
     * Gets cost
     *
     * @return int|null
     */
    public function getCost()
    {
        return $this->container['cost'];
    }

    /**
     * Sets cost
     *
     * @param int|null $cost Стоимость единицы товара с учетом НДС (в копейках)
     *
     * @return $this
     */
    public function setCost($cost)
    {


        /*if (is_null($cost)) {
            throw new \InvalidArgumentException('non-nullable cost cannot be null');
        }*/
        $this->container['cost'] = $cost;

        return $this;
    }

    /**
     * Gets cost_vat
     *
     * @return int|null
     */
    public function getCostVat()
    {
        return $this->container['cost_vat'];
    }

    /**
     * Sets cost_vat
     *
     * @param int|null $cost_vat Процентная ставка НДС
     *
     * @return $this
     */
    public function setCostVat($cost_vat)
    {


        /*if (is_null($cost_vat)) {
            throw new \InvalidArgumentException('non-nullable cost_vat cannot be null');
        }*/
        $this->container['cost_vat'] = $cost_vat;

        return $this;
    }

    /**
     * Gets price
     *
     * @return int|null
     */
    public function getPrice()
    {
        return $this->container['price'];
    }

    /**
     * Sets price
     *
     * @param int|null $price Цена единицы товара к оплате с учетом НДС (в копейках)
     *
     * @return $this
     */
    public function setPrice($price)
    {


        /*if (is_null($price)) {
            throw new \InvalidArgumentException('non-nullable price cannot be null');
        }*/
        $this->container['price'] = $price;

        return $this;
    }

    /**
     * Gets created_at
     *
     * @return \DateTime|null
     */
    public function getCreatedAt()
    {
        return $this->container['created_at'];
    }

    /**
     * Sets created_at
     *
     * @param \DateTime|null $created_at Дата создания
     *
     * @return $this
     */
    public function setCreatedAt($created_at)
    {


        /*if (is_null($created_at)) {
            throw new \InvalidArgumentException('non-nullable created_at cannot be null');
        }*/
        $this->container['created_at'] = $created_at;

        return $this;
    }

    /**
     * Gets updated_at
     *
     * @return \DateTime|null
     */
    public function getUpdatedAt()
    {
        return $this->container['updated_at'];
    }

    /**
     * Sets updated_at
     *
     * @param \DateTime|null $updated_at Дата обновления
     *
     * @return $this
     */
    public function setUpdatedAt($updated_at)
    {


        /*if (is_null($updated_at)) {
            throw new \InvalidArgumentException('non-nullable updated_at cannot be null');
        }*/
        $this->container['updated_at'] = $updated_at;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


